/******
        file     : readfst.c
        function : what you need to read the fst files

        created  : Oct 03 2003
        modif    : Aug 31 2004

			note    : read '\n' or '\r' as a carriage return
        author   : amikezor
*****/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "SharMot.h"


static long get_curfst(char *sequence, FILE *fseq)
{

	long lseq;
	int letter;
  
	lseq = 0;
  
	while( (letter=fgetc(fseq)) != '\n' && letter!= '\r' );    /* remove first line */

	while ((letter=fgetc(fseq)) != EOF || letter == '>')
		if (letter !='\n' && letter !='\r')
			sequence[lseq++]=letter;

	if(letter == '>')
		fseek(fseq, -1, SEEK_CUR);   /* get ready for the next sequence */

  sequence[lseq]=0;
  return lseq;
}


void invseq(char *seqsrc, char *seqdest)
{

	char *pseqsrc,
		  *pseqinv;

	pseqsrc=seqsrc;
	pseqinv=seqdest+strlen(seqsrc)-1;

  while(*pseqsrc){
     	  
		if(*pseqsrc == 'A' || *pseqsrc == 'a'){*pseqinv = 'T';}
		else if(*pseqsrc == 'C' || *pseqsrc == 'c'){*pseqinv = 'G';}
		else if(*pseqsrc == 'G' || *pseqsrc == 'g'){*pseqinv = 'C';}
		else if(*pseqsrc == 'T' || *pseqsrc == 't'){*pseqinv = 'A';}
		else if(*pseqsrc == 'X' || *pseqsrc == 'x'){*pseqinv = 'X';}
	   else{*pseqinv = 'N';}
		
		pseqinv--;
		pseqsrc++;
		
    }
	

	seqdest[strlen(seqsrc)]=0;

}


char *file2mem(char *file, long *size)  /*le pointeur size permet de recup la size */
{

	FILE *fseq=NULL;
	char *seq=NULL;
	char letter=0;
	int nseq=0;

	*size=0;

	fseq = fopen(file,"r");
	if(fseq == NULL)
		fprintf(stderr,"Flux error, check the fasta seq file\n"),exit(3);

	while( (letter=(char)fgetc(fseq)) != EOF ){
	
		if(letter == '>'){
			nseq++;
			while( (letter=(char)fgetc(fseq)) != '\n' && letter != '\r' );  /* remove the line */
			continue;
		}
		
		if( letter != '\n' && letter != '\r')
			(*size)++;
	}
		
	if( nseq != 1)
		fprintf(stderr,"there is not exactly ONE sequence in that file\n"),exit(2);

	seq = (char *)malloc((*size+1)*sizeof(char));
	if(!seq)fprintf(stderr,"get_chr: Malloc error"),exit(3);

	rewind(fseq);
	
	get_curfst(seq, fseq); 
	fclose(fseq);

	return seq;
}

