/******
        file     : traceback_SW.c
        function : traceback  from the highest score to a zero
                                                 
        created  : 6 Mar 2002
        modif    : 

		  author   : amikezor
*****/



#include "SharMot.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/*
	this function generate a char *traceback
	Moreover it count the identity percent
*/
void traceback_SW( char *seq1, char *seq2, SCORING * pScoring,  RESULTS *pResults , char direction){
	
	int score=0;
	char trace='d';
	int row,
	    col;
	int count=0;

	short Read_Mat;                /* if it becomes 0, do not read the matrix */
	short TwoWays=0;                 /* becomes 1 if we arrive in a both way are possible */


	row = pResults->BestScore_row;
	col = pResults->BestScore_col;	

	if(direction == 'a' || direction == 'l'){
		Read_Mat=0;
		trace = direction;
		score = pResults->BestScore+pScoring->gap_ext;  /* because it will be removed soon */
	}
	else
		Read_Mat=1;
	
	pResults->matches=0;
	pResults->alignment_len=0;
	
	do{
		/*
			Set trace
		*/
		if(Read_Mat)
			trace = Traces( row, col );         /* read the current trace */

		/*
			Set score
		*/
		if(Read_Mat)
			score = Scores( row, col );	      /* read the score in the mat */
		else
			score-=pScoring->gap_ext;           /* if not read, just decrease 1 from the score */

		if(score<=0)break;                       /* if score is 0 STOP */

		pResults->Begin_row = row;             /* Set the new begin of the alignment */
		pResults->Begin_col = col;
				
		if(trace == 'd'){                      /* what tell the trace ?? */
		
			if(seq1[row-1]==seq2[col-1])(pResults->matches)++;
			row--;
			col--;
		}
		else if(trace == 'l'){                  /* we are going to left */

			if( Scores(row,col-1) == (score-pScoring->gap_open) )
				Read_Mat=1;
			else
				Read_Mat=0;
			
			col--;
		}
		else if(trace == 'a'){                  /* we are exploring above */
			
			if( Scores(row-1,col) == (score-pScoring->gap_open) )
				Read_Mat=1;
			else
				Read_Mat=0;
			
			row--;
		}
		else{                 /* thus we have to choose between two ways , try recursively that function */
			TwoWays=1;
			break;		
		}
		
		pResults->traceback[count++]= trace;
		pResults->traceback[count]= 0;
		
	}
	while( 1 );

	pResults->alignment_len = count;
	pResults->traceback[count] = 0;
	
	
	if(TwoWays)
		explore2ways(seq1, seq2, pScoring,  pResults);
	
}

/*
	Free the tmp Results
*/
static void free_NewResults( RESULTS *pNewResults){
	free(pNewResults->traceback);
	free(pNewResults->F);
}


/*
	Create tmp results for exploration
*/
static void copy_NewResults(RESULTS *pResults, RESULTS *pNewResults, int BestRow, int BestCol, int BestScore){

	size_t size1, size2;
	
	size1 = pResults->size_row;
	size2 = pResults->size_col;

	pNewResults->scores = pResults->scores; 
	pNewResults->traces = pResults->traces; 

	pNewResults->F = (int *) calloc( size2, sizeof(int) );
	pNewResults->traceback = (char *)calloc(size1+size2, sizeof(char));
	if(!pNewResults->traceback || !pNewResults->F)
		fprintf(stderr," copy_NewResults: malloc error\n"),exit(3);
	
	pNewResults->size_row=(int)size1;                       /* size of the matrices */
	pNewResults->size_col=(int)size2;
	
	pNewResults->BestScore=BestScore;          /* best score and its position in matrix */
	pNewResults->BestScore_row=BestRow;
	pNewResults->BestScore_col=BestCol;

}

/*
	Send an explorer in each unknown direction (above and left)
	And retain the shortest way (the farer from the begining of sequences)
	Then set pResults taking into account the shortest way
*/

void explore2ways(char *seq1, char *seq2, SCORING *pScoring,  RESULTS *pResults){


	int score;
	
	int begrow_a,             /* the row where alignment has stop for above way */
	    begcol_a;
		 
	int begrow_l,
	    begcol_l;
		
	RESULTS above_Results;    /* used if we arrived in an unknow pass */
	RESULTS left_Results;     /* then we explore recursivelly both way */
	
	/*printf("Fork to explore\n");*/
	
	/*
		First explore above
	*/	
	score = Scores( pResults->Begin_row,pResults->Begin_col );
	copy_NewResults(pResults, &above_Results, pResults->Begin_row, pResults->Begin_col, score);  /* do the above backtrack */
	traceback_SW( seq1, seq2, pScoring,  &above_Results , 'a');

	 begrow_a  = above_Results.Begin_row;
	 begcol_a = above_Results.Begin_col;

	/*
		Then explore left
	*/
	score = Scores(pResults->Begin_row,pResults->Begin_col) ;
	copy_NewResults(pResults, &left_Results, pResults->Begin_row, pResults->Begin_col, score);  /* do the left backtrack */
	traceback_SW( seq1, seq2, pScoring,  &left_Results , 'l');

	begrow_l  = left_Results.Begin_row;
	begcol_l = left_Results.Begin_col;
	pResults->traceback[pResults->alignment_len]=0;


	/*
		Then determine the shortest way and merge results
	*/
	if( (begrow_a + begcol_a) > ( begrow_l + begcol_l ) ||
		 ( (begrow_a+begcol_a)==(begrow_l+begcol_l) &&  begrow_a>begrow_l )
		){
	
			
		pResults->Begin_row = above_Results.Begin_row;
		pResults->Begin_col = above_Results.Begin_col;
			
		strcpy(pResults->traceback+pResults->alignment_len, above_Results.traceback);
		
		pResults->matches += above_Results.matches;
		pResults->alignment_len += above_Results.alignment_len;
			
	}
	else{                                                                     /* The left was shorter */

		
		pResults->Begin_row = left_Results.Begin_row;
		pResults->Begin_col = left_Results.Begin_col;

		strcpy(pResults->traceback+pResults->alignment_len, left_Results.traceback);

		pResults->matches += left_Results.matches;
		pResults->alignment_len += left_Results.alignment_len;
			
		 
	}

	pResults->traceback[pResults->alignment_len] = 0;     /* en the string */

	free_NewResults(&above_Results);
	free_NewResults(&left_Results);
	
}




